/**************************************************************************************************|
|* Copyright 2019 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
//#define  USE_HY17M24
#include <hy17m24sfr.h>
#include <WDT.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: WDT_Open                                                                              |
|                                                                                                  |
|  Parameters:                                                                                     |
|         wdts      - [in]  DWDT_WDTCKDIV8    / DWDT_WDTCKDIV16   / DWDT_WDTCKDIV32 /       |
|                               DWDT_WDTCKDIV64  /  DWDT_WDTCKDIV2048  / DWDT_WDTCKDIV4096  |
|                               DWDT_WDTCKDIV8192 / DWDT_WDTCKDIV16384                                          |
|                                                                                                                                                               |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to open the Watch Dog Timer(WDT)                                   |
|-------------------------------------------------------------------------------------------------*/
void WDT_Open(unsigned char wdts) //Configure WDT overflow time
{
   WDT_Enable();
   WDT_WDTCKDivSelect(wdts);
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
